
filename   = 'H.txt'
foldername = "./sample/"

percentage = 0.88                           # Key judgment value %  ( percentage=0.88 )
n = 50                                      # n consecutive 1's are valid  ( n=50 )

pause_time = 0.5                            # Pause time
drawspeed  = 1                              # Drawing speed: slowest 1, can be set to 5 or higher.


import numpy 
import turtle
import time
turtle.setup(500, 500,None,None)            # turtle Window Size
turtle.bgcolor("darkgreen")                 # turtle Window Background color
turtle.bgpic(r'./background1.png')          # turtle Window Background image   
turtle.color("red")                         # turtle Brush color                            
turtle.pensize(5)                           # turtle Brush thickness
turtle.shape("circle")                      # turtle Brush 
turtle.speed(drawspeed)                     # Plot trajectory speed 0-10 
turtle.up()
turtle.goto(-150,150)                       # tart position, default 0,0 center , -150,150 upper left.
turtle.down()
 
def Draw():
    f=open( foldername+filename )           # Open file.               
    txt = f.readlines()                     # Read by line directly from a file to an array txt.
    lines = len(txt)-4                      # Number of valid lines = total lines - 4 file headers. ( Also waveform points )
    f.close()                               # Close file.
    data = 1.0 * numpy.arange(lines *4)     # Constructing one-dimensional arrays.
    data.shape = (lines, 4)                 # Convert to a two-dimensional array.
    for i in range(lines):                  
        line = txt[i+4].split()             # Because the first 4 lines are not needed, so line number plus 4, each line split into an array line.
        data[i,0] = line[2]
        data[i,1] = line[3]
        data[i,2] = line[4]
        data[i,3] = line[5]
   
    data1 = numpy.arange(lines * 2)/2.0     # Construct 4 two-dimensional arrays.
    data1.shape = (lines, 2)
    data2 = numpy.arange(lines * 2)/2.0
    data2.shape = (lines, 2)
    data3 = numpy.arange(lines * 2)/2.0     
    data3.shape = (lines, 2)
    data4 = numpy.arange(lines * 2)/2.0
    data4.shape = (lines, 2)
    
    data1[:,1] = data[:,0]                  # Assignment, each two-dimensional array corresponds to a set of waveforms.
    data2[:,1] = data[:,1]
    data3[:,1] = data[:,2]
    data4[:,1] = data[:,3]

    max1= numpy.max(data1)                  # Maximum value of waveform per group.
    max2= numpy.max(data2)
    max3= numpy.max(data3)
    max4= numpy.max(data4)    
    
    for i in range(lines):                  # Set 0 if below the maximum value xx%, 1 if above.
        if data1[i,1] < max1 * percentage:
            data1[i,1] = 0
        else:
            data1[i,1] = 1

    for i in range(lines):
        if data2[i,1] < max2 * percentage:
            data2[i,1] = 0
        else:
            data2[i,1] = 1

    for i in range(lines):
        if data3[i,1] < max3 * percentage:
            data3[i,1] = 0
        else:
            data3[i,1] = 1
            
    for i in range(lines):
        if data4[i,1] < max4 * percentage:
            data4[i,1] = 0
        else:
            data4[i,1] = 1


    data5 = numpy.arange(lines)             # Constructing one-dimensional arrays.
    for i in range(lines):
        data5[i]=0

    for i in range(lines-n):                # If the sum of four waveforms = 1, and n waveforms are consecutive, the marker is 1.    
        data5[i] = 0        
        if ( data1[i,1]+data2[i,1]+data3[i,1]+data4[i,1] == 1)&( data1[i+1,1]+data2[i+1,1]+data3[i+1,1]+data4[i+1,1] == 1)&( data1[i+n,1]+data2[i+n,1]+data3[i+n,1]+data4[i+n,1] == 1):
            #print(i)
            data5[i] = 1

    for i in range(lines):                  # Check in reverse order, keeping only the first of several consecutive 1's.
        if data5[lines-i-1]==1:
            data5[lines-i]=0

    for i in range(lines):
        if data5[i] ==1 :
            orient = data1[i,1] +  data2[i,1]*2 + data3[i,1]*4 + data4[i,1]*8   # 4 binary bits, one for each.
            print ( int(orient) )

            if int(orient) ==1 :            # 1 2 4 8 corresponding to 4 directions respectively .
                turtle.seth(90)             # Absolute direction of the brush, in degrees °.
            if int(orient) ==2 :
                turtle.seth(270)
            if int(orient) ==4 :
                turtle.seth(0)
            if int(orient) ==8 :
                turtle.seth(180)            
            turtle.forward( 150 )           # Size of each grid.
            time.sleep(pause_time)


Draw()            
